
//REGEN_FILEHEADING
 // Horton's Egg by Richard Fennimore released to Public Domain.
 // Program Creates a self decorating egg (really a sphere in this case).
 // A math coprocessor is recommended as it significantly speeds up the program.
 // You're given a choice of 2 equasions. Result=Alpha*(sin(x)+sin(y)) and
 // result = Alpha *( (x*x)+(y*y)).
 // The algorithm is that if you take the result of either equasion and take its
 // modulus, if the remainder=0 color the point. This will form a pattern.
 // The outline of the sphere is drawn and then filled in by scanning the surface
 // of the sphere using longitude & latitude each of which varies from 0 to 180 degrees
 // in increments determined by the Resolution. For example if the Resolution=180
 // then the increment is one degree and if the Resolution=1800 then the increment
 // is a tenth of a degree. In this implementation I have chosen the color red for
 // the case when the remainder=0 and white for all other results. Note that if you
 // get any black areas in your egg, they can be eliminated by increasing the resolution
 // If you know of any entry level job openings for someone with a Master's Degree in
 // Computer Science please contact me. I'm available. Compuserve Address is 72760,1701
//REGEN_FILEHEADING


     /********************************************************************
      *                                                                  *
      *   Source File: horton.cpp                                        *
      *   Description: C++ Source file for horton application            *
      *   Date:        Tue Aug 03 17:27:08 1993                          *
      *                                                                  *
      ********************************************************************/

#include <owl.h>
#include <edit.h>
#include <listbox.h>
#include <combobox.h>
#include <scrollba.h>
#include <dialog.h>
#include <bwcc.h>
#include "hortonID.h"
#include "horton.h"

//REGEN_VARIABLES
#include <checkbox.h>
#include <math.h>

static POINT pt;
static int Resolution, m; static double Radius,Alpha; // m is the modulus
static BOOL Use_sine_equasion; 
const Pi=3.141592654;

class threeDpoint {     
		public:
		double X,Y,Z;
		threeDpoint (double x, double y, double z) {X=x;Y=y;Z=z;}
		void Xtranslate (double tx) {X=X+tx;}
		void Ytranslate (double ty) {Y=Y+ty;}
		void Ztranslate (double tz) { Z=Z+tz;}
		void rotateZaxis (double Zangle) { X = X*cos(Zangle) + X*sin(Zangle);
					    Y = (-Y)*sin(Zangle) + Y * cos(Zangle);}
		void rotateYaxis (double Yangle){
				X = (-X)*cos(Yangle) - X*sin(Yangle);
				Z = (-Z)*sin(Yangle) + Z*cos(Yangle); }
		void rotateXaxis (double Xangle){
				Y = Y*cos(Xangle) + Y*sin(Xangle);
				Z = (-Z)*sin(Xangle) + Z*cos(Xangle); }
	       POINT projection (double distance) {
				POINT p;
				p.x = (int) (distance * X/Z);
				p.y = (int) (distance * Y/Z);
				return p; }
	       }; // end of threeDpoint class

class sphere : public threeDpoint{
	double radius;
        public:
	sphere (double r,double x,double y,double z):threeDpoint(x,y,z){
		radius = r;}
   void	calworldcord (double longitude, double latitude){
		double tmp = sin (latitude) * radius;
		Y = cos(latitude)*radius;
		X = cos(longitude)*tmp;
		Z = sin(longitude)*tmp; }
                                 }; // end of sphere class


//REGEN_VARIABLES

// Define application class derived from  TApplication
class Thorton : public TApplication
{
public:
  Thorton(LPSTR AName, HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
    : TApplication(AName, hInstance, hPrevInstance, lpCmdLine, nCmdShow) {};
    virtual void InitMainWindow();
    //REGEN_APPCLASS
    //REGEN_APPCLASS
};

// Declare TMainWindow, a TWindow descendant
class TMainWindow : public TWindow
{
public:
   TMainWindow(PTWindowsObject AParent, LPSTR ATitle);
   ~TMainWindow();
   virtual void PARAMETERS(RTMessage Msg) = [CM_FIRST + IDM_PARAMETERS];
   virtual void CHOOSEEQUASION(RTMessage Msg) = [CM_FIRST + IDM_CHOOSEEQUASION];
   virtual void DRAW(RTMessage Msg) = [CM_FIRST + IDM_DRAW];
   //REGEN_MAINCLASS
   //REGEN_MAINCLASS

protected:
   virtual void GetWindowClass(WNDCLASS _FAR & AWndClass);
   virtual LPSTR GetClassName();
};


/****************************************************
 * TMainWindow implementations: 
 ****************************************************/

// Define TMainWindow, a TWindow constructor
TMainWindow::TMainWindow(PTWindowsObject AParent, LPSTR ATitle)
                         : TWindow(AParent, ATitle)
{
   AssignMenu("Horton");
   //REGEN_MAINCONSTRUCT
   //REGEN_MAINCONSTRUCT

}

// Define TMainWindow destructor
TMainWindow::~TMainWindow()
{
   //REGEN_MAINDESTRUCT
   //REGEN_MAINDESTRUCT

}

LPSTR TMainWindow::GetClassName()
{
   return "MainWindow";
}

void TMainWindow::GetWindowClass(WNDCLASS _FAR & AWndClass)
{
   TWindow::GetWindowClass(AWndClass);
   AWndClass.hbrBackground = CreateSolidBrush(0x0);
   //REGEN_CLASSINFO
  
   //REGEN_CLASSINFO

}

_CLASSDEF(TEQDlg)

// Declare TEQDlg, a TDialog descendant
class TEQDlg : public TDialog 
{
public:
   TCheckBox * CheckBox102; TCheckBox * CheckBox103;
   TGroupBox * GroupBox; 
   TEQDlg(PTWindowsObject AParent, LPSTR AName);
   ~TEQDlg();
   virtual void RTEQ102(RTMessage Msg) = [ID_FIRST + 102];
   virtual void RTEQ103(RTMessage Msg) = [ID_FIRST + 103];
   //REGEN_EQ_CLASS
    virtual void SetupWindow();
   //REGEN_EQ_CLASS

};

_CLASSDEF(TParamDlg)

// Declare TParamDlg, a TDialog descendant
class TParamDlg : public TDialog 
{
public:
   PTEdit Edit101;
   PTEdit Edit102;
   PTEdit Edit103;
   PTEdit Edit106;

   TParamDlg(PTWindowsObject AParent, LPSTR AName);
   ~TParamDlg();
   virtual void Ok(RTMessage Msg) = [ID_FIRST + IDOK];
   virtual void Cancel(RTMessage Msg) = [ID_FIRST + IDCANCEL];
   //REGEN_Param_CLASS
   virtual void SetupWindow();
   //Edit101-Resolution,Edit102-Radius,Edit103-alpha, Edit106-modulus
   //REGEN_Param_CLASS

};

// Define TEQDlg, a TDialog constructor
TEQDlg::TEQDlg(PTWindowsObject AParent, LPSTR AName)
               :TDialog(AParent, AName)
{

   //REGEN_EQ_CONSTRUCTOR
   GroupBox = new TGroupBox(this,101);
   CheckBox102 = new TCheckBox(this,102,GroupBox);
   CheckBox103 = new TCheckBox(this,103,GroupBox);

   //REGEN_EQ_CONSTRUCTOR

}

// Define TEQDlg destructor
TEQDlg::~TEQDlg()
{

   //REGEN_EQ_DESTRUCTOR
   delete CheckBox102; delete CheckBox103; delete GroupBox;
   //REGEN_EQ_DESTRUCTOR

}

void TEQDlg::RTEQ102(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
      //REGEN_EQ102_ROUTING
      Use_sine_equasion=TRUE;
      CheckBox102->Check(); CheckBox103->Uncheck();
      //REGEN_EQ102_ROUTING
      break;
   }
}

void TEQDlg::RTEQ103(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
      //REGEN_EQ103_ROUTING
      Use_sine_equasion=FALSE;
      CheckBox103->Check(); CheckBox102->Uncheck();
      //REGEN_EQ103_ROUTING
      break;
   }
}

// Define TParamDlg, a TDialog constructor
TParamDlg::TParamDlg(PTWindowsObject AParent, LPSTR AName)
               :TDialog(AParent, AName)
{

   Edit101 = new TEdit(this, 101, 0);
   Edit102 = new TEdit(this, 102, 0);
   Edit103 = new TEdit(this, 103, 0);
   Edit106 = new TEdit(this, 106, 0);
   //REGEN_Param_CONSTRUCTOR
   //REGEN_Param_CONSTRUCTOR

}

// Define TParamDlg destructor
TParamDlg::~TParamDlg()
{

   //REGEN_Param_DESTRUCTOR
   //REGEN_Param_DESTRUCTOR

   delete Edit101;
   delete Edit102;
   delete Edit103;
   delete Edit106;
}

void TParamDlg::Ok(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
      //REGEN_ParamIDOK_ROUTING
           char restxt[25];char radtxt[25]; char alphtxt[25];char mtxt[25];
      Edit101->GetText(restxt,sizeof(restxt));
      Resolution=atoi(restxt);
      Edit102->GetText(radtxt,sizeof(radtxt));
      Radius=atof(radtxt);
      Edit103->GetText(alphtxt,sizeof(alphtxt));
      Alpha=atof(alphtxt);
      Edit106->GetText(mtxt,sizeof(mtxt));
      m=atoi(mtxt);
      if( (Resolution<0)||(Radius<0)||(Alpha<0) )
		MessageBox(NULL,"Horton's Gonna Sit on You for Entering a Negative NUmber",
		"ERROR",MB_ICONSTOP|MB_OK);
      else
      if (Radius<1) MessageBox(NULL,"That Egg is too Small for Horton","ERROR",
	MB_ICONSTOP|MB_OK);
      else
      if (m<2) MessageBox(NULL,"Horton's giving you 30 lashes with his trunk for entering a modulus < 2",
	"ERROR",MB_ICONSTOP|MB_OK);
      else				 			
      CloseWindow();

      //REGEN_ParamIDOK_ROUTING
       //  TDialog::Ok(Msg);
   }
}

void TParamDlg::Cancel(RTMessage Msg)
{
   switch(Msg.LP.Hi)
   {
      case BN_CLICKED :
      //REGEN_ParamIDCANCEL_ROUTING
      //REGEN_ParamIDCANCEL_ROUTING
         TDialog::Cancel(Msg);
   }
}

void TMainWindow::PARAMETERS(RTMessage)
{
   // Execute modal dialog
   if (GetModule()->ExecDialog(
               new TParamDlg(this, "Param")) == IDOK )
   {
   //REGEN_PARAMETERS_EXEC
   //REGEN_PARAMETERS_EXEC

   }
}

void TMainWindow::CHOOSEEQUASION(RTMessage)
{
   // Execute modal dialog
   if (GetModule()->ExecDialog(
               new TEQDlg(this, "EQ")) == IDOK )
   {
   //REGEN_CHOOSEEQUASION_EXEC
   //REGEN_CHOOSEEQUASION_EXEC

   }
}

void TMainWindow::DRAW(RTMessage)
{
   //REGEN_DRAW_EXEC
   TMainWindow::SetCaption( "Don't Bother me I'm Coloring my Egg !!!");
   HDC hdc = GetDC(HWindow);
   RECT rt;GetClientRect(HWindow,&rt);
   InvalidateRect(HWindow,&rt,TRUE); UpdateWindow(HWindow);
   SetWindowOrg(hdc, -(rt.right/2),-(rt.bottom/2));
   SelectObject(hdc, GetStockObject (WHITE_PEN));
   sphere s (Radius,0.0,0.0,0.0);
   s.calworldcord(0.0,0.0); // Draw Outline of Sphere
   s.rotateYaxis(0.0);
   s.Ztranslate(-150.0);
   pt = s.projection(1200);
   MoveTo (hdc,pt.x,pt.y);
   for (int i=1;i<361;i++)
	{
	 s.calworldcord(0.0,6.28318*((double) i/360) );
         s.rotateYaxis(0.0);
         s.Ztranslate(-150.0);
         pt = s.projection(1200);
	 LineTo (hdc, pt.x , pt.y);
         MoveTo (hdc,pt.x,pt.y);
	 }
 // Get point on Sphere using Longitude & Latitude. If remaider=0 color point red.
 // Otherwise color point white 
    for (i=0;i<Resolution;i++)
	for (int k=0;k<Resolution;k++)
		{
		
		double Longitude=Pi*((double) i/Resolution);
		double Latitude=Pi*((double) k/Resolution);
		s.calworldcord(Longitude,Latitude);
                s.rotateYaxis(0.0);
                s.Ztranslate(-150.0);
		pt = s.projection(1200);		
		int result = (Use_sine_equasion==TRUE)? (int)(Alpha * (sin (pt.x) + sin (pt.y))):
                              (int)(Alpha * (pt.x * pt.x + pt.y * pt.y));
		if (result%m == 0) SetPixel( hdc,pt.x,pt.y,RGB(255,0,0));
		else SetPixel( hdc,pt.x,pt.y,RGB(255,255,255));
	        
                }
                    
   ReleaseDC (HWindow,hdc);
   TMainWindow::SetCaption( "**Finished**");
   //REGEN_DRAW_EXEC
}


/***************************************************
 * ThortonApp method implementations:
 ***************************************************/
 
// Construct the Thorton's MainWindow of type TMainWindow
void Thorton::InitMainWindow()
{
   MainWindow = new TMainWindow(NULL, Name);
   //REGEN_MAINCREATE
    MessageBox(NULL,"Horton Will Not allow you to run another program\
 until it Finishes Drawing. You'll have to resort to ctrl-alt-delete\
 if you want to stop it before it finishes",
    "Important Info",MB_ICONINFORMATION|MB_OK);

   //REGEN_MAINCREATE
}
// Main program
int PASCAL WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow)
{
   HINSTANCE hBorLibrary;

   hBorLibrary = LoadLibrary("bwcc.dll");

   if((UINT)hBorLibrary <= 32)
      MessageBox(NULL, "Unable to load Borland Controls", "System Error", MB_OK | MB_ICONHAND);

   //REGEN_INIT
   // default values draws nice eggs
   Resolution=720;Radius=23;Alpha=2.718281828; Use_sine_equasion=TRUE;m=2; 
   //REGEN_INIT

   Thorton horton ("Horton's Egg by R.Fennimore", hInstance, hPrevInstance,
      lpCmdLine, nCmdShow);

   horton.Run();

   if((UINT)hBorLibrary > 32)
      FreeLibrary(hBorLibrary);

   //REGEN_CLEANUP
   //REGEN_CLEANUP

   return horton.Status;
}

//REGEN_CUSTOMCODE
void TParamDlg::SetupWindow()
{
TDialog::SetupWindow();
   int dec,sign;char str[25];
   Edit101->SetText(gcvt(Resolution,10,str));
   Edit102->SetText(gcvt(Radius,10,str));
   Edit103->SetText(gcvt(Alpha,10,str));
   Edit106->SetText(gcvt(m,10,str));
}

void TEQDlg::SetupWindow()
{
TDialog::SetupWindow();
 if ( Use_sine_equasion == TRUE) CheckBox102->Check();
 else CheckBox103->Check();
 }
//REGEN_CUSTOMCODE
